require "import"
import "android.content.Context"
import "android.os.Vibrator"
import "android.media.ToneGenerator"
import "android.media.AudioManager"
import "android.widget.*"
import "com.androlua.*"
import "android.net.Uri"
import "android.content.Intent"
import "android.text.Html"
local context = activity or service
local vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)
vibrator.vibrate(40)

local translationResult = ""

local languageCodes = {
    ["Việt"] = "vi",
    ["Anh"] = "en",
    ["Trung quốc"] = "zh-CN",
    ["Tây ban nha"] = "es",
    ["Afrikaan, nam phi"] = "af",
    ["Amharic, ethiopia"] = "am",
    ["Albani"] = "sq",
    ["Ả rập"] = "ar",
    ["Armenia"] = "hy",
    ["Amsam, ấn độ"] = "as",
    ["Azerbaijan"] = "az",
    ["Bangladesh"] = "bn",
    ["Basque, tây ban nha"] = "eu",
    ["Bengali, ấn độ"] = "bn",
    ["Belarus"] = "be",
    ["Bulgaria"] = "bg",
    ["Bồ Đào Nha"] = "pt",
    ["Bosnia"] = "bs",
    ["Canary"] = "kn",
    ["Catalan, tây ban nha"] = "ca",
    ["Cebuano, philippines"] = "ceb",
    ["Cornish"] = "kw",
    ["Corsica, pháp"] = "co",
    ["Croatia"] = "hr",
    ["Czech"] = "cs",
    ["Dutch"] = "nl",
    ["Đan Mạch"] = "da",
    ["Đài loan, trung quốc"] = "zh-TW",
    ["Đức"] = "de",
    ["Do thái"] = "iw",
    ["Estonia"] = "et",
    ["Frisian, hà lan"] = "fy",
    ["Galicia, tây ban nha"] = "gl",
    ["Gruzia"] = "ka",
    ["Gujarati, ấn độ"] = "gu",
    ["Hà lan"] = "nl",
    ["Haiti"] = "ht",
    ["Hàn quốc"] = "ko",
    ["Hausa"] = "ha",
    ["Hawaii"] = "haw",
    ["Hebrew, israel"] = "he",
    ["Hindi, ấn độ"] = "hi",
    ["Hồng công, trung quốc"] = "zh-yue",
    ["Hy lạp"] = "el",
    ["H'mông, trung quốc"] = "hmn",
    ["Hungari"] = "hu",
    ["Igbo, nigeria"] = "ig",
    ["Iceland"] = "is",
    ["Indonesia"] = "id",
    ["Ítalia"] = "it",
    ["Ireland"] = "ga",
    ["Javanese, indonesia"] = "jv",
    ["Kazakhstan"] = "kk",
    ["Khmer, campuchia"] = "km",
    ["Kannada"] = "kn",
    ["Kinyawanda, rwanda"] = "rw",
    ["kurd, thổ nhĩ kì"] = "ku",
    ["Kyrgyzstan"] = "ky",
    ["Lào"] = "lo",
    ["Latin, thành vatican"] = "la",
    ["Latvia"] = "lv",
    ["Litva"] = "lt",
    ["Luxembourg"] = "lb",
   ["Macedonia"] = "mk",
    ["Malagasi, madagascar"] = "mg",
    ["Malaysia"] = "ms",
    ["Malayalam, ấn độ"] = "ml",
    ["Malta"] = "mt",
    ["Manx"] = "gv",
    ["Maori, new zealand"] = "mi",
    ["Marathi, ấn độ"] = "mr",
    ["Myanmar"] = "my",
    ["Mông cổ"] = "mn",
    ["Na uy, pokmal"] = "no",
    ["Nepan"] = "ne",
    ["Nga"] = "ru",
    ["Nhật bản"] = "ja",
    ["Nyanja, malawi"] = "ny",
    ["Odia, ấn độ"] = "or",
    ["Pa lan"] = "pl",
    ["Ba Tư, iran"] = "fa",
    ["Pashto, afghanistan"] = "ps",
    ["Phần lan"] = "fi",
    ["Philippines"] = "fil",
    ["Pháp"] = "fr",
    ["Pungabi, ấn độ"] = "pa",
    ["Rumani"] = "ro",
    ["Samoa"] = "sm",
    ["Scotland"] = "gd",
    ["Sesotho, lesotho"] = "st",
    ["Singapo"] = "zh-SG",
    ["Serbia"] = "sr",
    ["Sindhi, pakistan"] = "sd",
    ["Sinhala, siri lanka"] = "si",
    ["Slovakia"] = "sk",
    ["Slovenia"] = "sl",
    ["Somali, somalia"] = "so",
    ["Shona, zimbabwe"] = "sn",
    ["Swahili"] = "sw",
    ["Sundanese, indonesia"] = "su",
    ["Tajikistan"] = "tg",
    ["Tamil, ấn độ"] = "ta",
    ["Tagalog"] = "tl",
    ["Tatar"] = "tt",
    ["Telugu, ấn độ"] = "te",
    ["Thái Lan"] = "th",
    ["Thổ Nhĩ Kỳ"] = "tr",
    ["Thụy Điển"] = "sv",
    ["Turkmenistan"] = "tk",
    ["Urdu, ấn độ"] = "ur",
    ["Ukraine"] = "uk",
    ["Uighur, trung quốc"] = "ug-CN",
    ["Uzbek"] = "uz",
    ["Xứ Wales"] = "cy",
    ["Zulu"] = "zu",
}

local items = {
    "Việt",
    "Anh",
    "Ả rập",
    "Nga",
    "Tây ban nha",
    "Trung quốc",
    "Afrikaan, nam phi",
    "Amharic, ethiopia",
    "Albani",
    "Armenia",
    "Amsam, ấn độ",
    "Azerbaijan",
    "Basque, tây ban nha",
    "Bangladesh",
    "Bengali, ấn độ",
    "Belarus",
    "Bồ Đào Nha",
    "Bosnia",
    "Bungari",
    "Canary",
     "Catalan, tây ban nha",
    "Cebuano, philippines",
    "Cornish",
    "Corsica, pháp",
    "Croatia",
    "Czech",
    "Do thái",
    "Dutch",
    "Đan Mạch",
    "Đài loan, trung quốc",
    "Đức",
    "Estonia",
    "Frisian, hà lan",
    "Galicia, tây ban nha",
        "Gruzia",
    "Gujarati, ấn độ",
    "Hà lan",
    "Haiti",
    "Hàn quốc",
    "Hausa",
    "Hawaii",
    "Hindi, ấn độ",
    "Hồng công, trung quốc",
    "Hy lạp",
    "H'mông, trung quốc",
    "Hungari",
    "Igbo, nigeria",
    "Iceland",
    "Indonesia",
    "Ireland",
    "Italia",
    "Kazakhstan",
    "Khmer, campuchia",
    "Kannada",
    "Kinyawanda, rwanda",
    "Kurd, thổ nhĩ kì",
    "Kyrgyzstan",
    "Lào",
    "Latin, thành vatican",
    "latvia",
    "Litva",
    "Luxembourg",
    "Macedonia",
    "Malagasi, madagascar",
    "Malaysia",
    "malayalam, ấn độ",
    "malta",
    "Manx",
    "Maori, new zealand",
    "Marathi, ấn độ",
    "Myanmar",
    "Mông cổ",
    "Na uy, pokmal",
    "Nepan",
    "Nhật bản",
    "Nyanja, malawi",
    "Odia, ấn độ",
    "Pa lan",
    "Pa tư, iran",
    "Pashto, afghanistan",
    "Phần lan",
    "philippines",
    "Pháp",
    "Punjabi, ấn độ",
    "Rumani",
    "Samoa",
    "Scotland",
    "Sesotho, lesotho",
    "Singapo",
    "serbia",
    "Sindhi, pakistan",
    "Sinhala, siri lanka",
    "Slovakia",
    "Slovenia",
    "Somali, somalia",
    "Shona, zimbabwe",
    "Swahili",
    "Sundanese, indonesia",
    "Tajikistan",
    "Tamil, ấn độ",
    "Tagalog",
    "Tatar",
    "Telugu, ấn độ",
    "Thái Lan",
    "Thụy Điển",
    "Thổ Nhĩ Kỳ",
    "Turkmenistan",
    "Ukraine",
    "urdru, ấn độ",
    "Uighur, trung quốc",
    "Uzbek",
    "xứ Wales",
    "Zulu"
}

function capitalizeFirstWord(str)
    return str:gsub("^%l", string.upper)
end

function addPunctuation(str)
    return str .. "."
end

function hasInternetConnection()
local connectivityManager = this.getSystemService(Context.CONNECTIVITY_SERVICE)
local networkInfo = connectivityManager.getActiveNetworkInfo()
return networkInfo ~= nil and networkInfo.isConnected()
end

if not hasInternetConnection() then
service.asyncSpeak("Không có kết nối Internet. không thể dịch ngôn ngữ.")
return false
end

local layout = {
  GridView,
  id = "grid",
  numColumns = 1,
  layout_width = "fill",
  layout_height = "fill"
}

local dlg = LuaDialog(this)
dlg.View = loadlayout(layout)
grid.adapter = SingleLineAdapter(service, String(items))

dlg.setTitle("Dịch nhanh đa ngôn ngữ")
.setMessage("Chọn ngôn ngữ bạn muốn dịch sang.")
  .setButton("Thoát", nil)
  .show()

grid.onItemClick = function(l, v)
  dlg.dismiss()
  task(500, function()
    local language = v.text
    local defaultLanguage = Locale.getDefault().getLanguage()
    local languageCode = languageCodes[language]

    if languageCode then
      local url = "https://translate.google.com/m?sl=auto&hl=" .. defaultLanguage .. "&q=" .. Uri.encode(this.getText(node))
      url = url .. "&tl=" .. languageCode

      Http.get(url, function(status, result)
        if status == 200 then
local translation = tostring(Html.fromHtml(result:match('<div class="result%-container">([^<]+)</div>')))
        translation = capitalizeFirstWord(translation)
        translation = addPunctuation(translation)
        translationResult = translationResult .. translation
        
service.setText(translationResult)
service.speak("đã Dịch  văn bản với nội dung: " .. translationResult)
vibrator.vibrate(100)
        else
print("Rất tiếc, đã xảy ra sự cố.\n Những phương pháp này có thể hữu ích: \n - Đảm bảo bạn đã kết nối với Internet. \n - Cố gắng cung cấp một kết nối Internet tốt. \n Lưu ý: Một số mục, hình ảnh, hộp chỉnh sửa, v.v., không thể dịch được.")
vibrator.vibrate(200)
service.playSoundTick()
        end
      end)
    else
print("Ngôn ngữ không được hỗ trợ")
vibrator.vibrate(200)
service.playSoundClock()
    end
  end)
end